//  

public class OpcodeTable {
    // 
    static final String [] Opcodes = new String [] {
        "ADD", "SUB", "CLR", "CPY", "BR", "BRZ", "JSR", "RET", "IN", "OUT", "NOP", "HLT"};

    //  
    static final int CMD_ADD = 0,
                     CMD_SUB = 1,
                     CMD_CLR = 2,
                     CMD_CPY = 3,
                     CMD_BR  = 4,
                     CMD_BRZ = 5,
                     CMD_JSR = 6,
                     CMD_RET = 7,
                     CMD_IN  = 8,
                     CMD_OUT = 9,
                     CMD_NOP = 10,
                     CMD_HLT = 11,
                     CMD_UND = -1;

    //  
    static boolean isMnemonic (String mn) {
        for (int i = 0; i < Opcodes.length; i++) {
            if (Opcodes [i].equals (mn)) return true;
        }
        return false;
    }

    //     
    static int opcodeFromString (String mn) {
        if      (mn.equals ("ADD")) return CMD_ADD;
        else if (mn.equals ("SUB")) return CMD_SUB;
        else if (mn.equals ("CLR")) return CMD_CLR;
        else if (mn.equals ("CPY")) return CMD_CPY;
        else if (mn.equals ("BR" )) return CMD_BR;
        else if (mn.equals ("BRZ")) return CMD_BRZ;
        else if (mn.equals ("JSR")) return CMD_JSR;
        else if (mn.equals ("RET")) return CMD_RET;
        else if (mn.equals ("IN" )) return CMD_IN;
        else if (mn.equals ("OUT")) return CMD_OUT;
        else if (mn.equals ("NOP")) return CMD_NOP;
        else if (mn.equals ("HLT")) return CMD_HLT;
        else return CMD_UND;
    }
}
