//  
import java.util.*;

public class SymbolTable {
    public static Map <String, Symbol> symtab;

    public SymbolTable () {
        symtab = new HashMap <String, Symbol> ();
    }

    //   
    public boolean lookupSymbol (String name) {
        if (symtab.get (name) == null) return false;
        return true;
    }

    //     
    public void putSymbol (String name, char type, int value) {
        if (symtab.get (name) == null) symtab.put (name, new Symbol (type, value));
    }

    //   
    public char getType (String name) {
        Symbol sym = (Symbol)symtab.get (name);
        char type = (sym != null ? sym.getType () : 'U');
        return type;
    }

    //   
    public int getValue (String name) {
        Symbol sym = (Symbol)symtab.get (name);
        int value = (sym != null ? sym.getValue () : 0);
        return value;
    }

    //   
    public void printSymbolTable () {
        Set <Map.Entry <String, Symbol>> entries = symtab.entrySet ();

        System.out.printf ("+---------------------------+\n");
        System.out.printf ("|SYMBOL TABLE               |\n");
        System.out.printf ("+----------------+-+--------+\n");
        System.out.printf ("|Symbol          |T|   Value|\n");
        System.out.printf ("+----------------+-+--------+\n");
        for (Map.Entry <String, Symbol> entry : entries) {
            String key   = entry.getKey ();
            System.out.printf ("|%-16.16s|%1s|%8d|\n",
                                key,
                                getType (key),
                                getValue (key));
        }
        System.out.printf ("+----------------+-+--------+\n");
    }
}

//  
class Symbol {
    private char type;
    private int  value;

    Symbol (char type, int value) {
        this.type  = type;                                                      //  : L/N (/)
        this.value = value;
    }

    //        
    public char getType  () {return type;}
    public int  getValue () {return value;}
}
